class BaseObject:
    TYPE = None

    def __init__(self, feature):
        print(self.__class__)
        self.feature = feature

        feature.Proxy = self

        self.setup_properties(feature)
        self.setup_extensions(feature)

        feature.Type = self.TYPE

    def execute(self, feature):
        pass

    def setup_extensions(self):
        if hasattr(self.parent.__class__, 'EXTENSIONS'):
            for ext in self.parent.__class__.EXTENSIONS:
                self.feature.addExtension(ext)

    def onBeforeChange(self, feature, prop):
        pass

    def onChanged(self, feature, prop):
        pass

    def onDocumentRestored(self, feature):
        self.feature = feature

    def setup_extensions(self, feature):
        if hasattr(self, 'EXTENSIONS'):
            for ext in self.EXTENSIONS:
                self.feature.addExtension(ext)

    def setup_properties(self, feature):
        feature.addProperty('App::PropertyString', 'Type', 'KiConnect', 'Internatl KiConnect Type', read_only=True, hidden=True)

    def __getstate__(self):
        return None
